<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 5: Functions and Program Structure</title>
<link href="sx4d.html" rev=precedes>
<link href="sx5a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 5: Functions and Program Structure</H1>

<p>[This chapter corresponds to K&amp;R chapter 4.]
</p><p>A function is a ``black box'' that we've locked
part of our program into.
The idea behind a function is that it <dfn>compartmentalizes</dfn>
part of the program,
and in particular,
that the code within the function has some useful properties:
<OL><li>It performs some well-defined task,
which will be useful to other parts of the program.
<li>It might be useful to other programs as well;
that is,
we might be able to reuse it
(and without having to rewrite it).
<li>The rest of the program doesn't have to know the details of how
the function is implemented.
This can make the rest of the program easier to think about.
<li>The function performs its task <em>well</em>.
It may be written to do a little more than is required by the
first program that calls it,
with the anticipation that the calling program
(or some other program)
may later need the extra functionality or improved performance.
(It's important that a finished function do its job well,
otherwise there might be a reluctance to call it,
and it therefore might not achieve the goal of reusability.)
<li>By placing the code to perform the useful task into a function,
and simply calling the function in the other parts of the
program where the task must be performed,
the rest of the program becomes clearer:
rather than having some large, complicated,
difficult-to-understand piece of code repeated wherever the
task is being performed,
we have a single simple function call,
and the name of the function reminds us which task is being
performed.
<li>Since the rest of the program doesn't have to know the details of how
the function is implemented,
the rest of the program doesn't care if the function is
reimplemented later,
in some different way
(as long as it continues to perform its same task, of course!).
This means that one part of the program can be rewritten,
to improve performance or add a new feature
(or simply to fix a bug),
without having to rewrite the rest of the program.
</OL></p><p>Functions are probably the most important weapon
in our battle against software complexity.
You'll want to learn when it's appropriate
to break processing out into functions
(and also when it's not),
and <em>how</em> to set up function interfaces
to best achieve the qualities mentioned above:
reuseability,
information hiding,
clarity,
and
maintainability.
</p><p><a href="sx5a.html" rel=subdocument>5.1 Function Basics</a></p>
<p><a href="sx5b.html" rel=subdocument>5.2 Function Prototypes</a></p>
<p><a href="sx5c.html" rel=subdocument>5.3 Function Philosophy</a></p>
<p><a href="sx5d.html" rel=subdocument>5.4 Separate Compilation--Logistics</a></p>
<hr>
<p>
Read sequentially:
<a href="sx4d.html" rev=precedes>prev</a>
<a href="sx5a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
